from typing import Dict, List, Optional, Union

from weaviate.rbac.models import PermissionsType, Role, User
from weaviate.rbac.roles import _RolesBase

class _Roles(_RolesBase):
    def list_all(self) -> Dict[str, Role]: ...
    def get_current_roles(self) -> Dict[str, Role]: ...
    def by_name(self, role: str) -> Optional[Role]: ...
    def by_user(self, user: str) -> Dict[str, Role]: ...
    def users(self, role: str) -> Dict[str, User]: ...
    def delete(self, role: str) -> None: ...
    def create(self, *, name: str, permissions: PermissionsType) -> Role: ...
    def assign(self, *, roles: Union[str, List[str]], user: str) -> None: ...
    def revoke(self, *, roles: Union[str, List[str]], user: str) -> None: ...
    def add_permissions(self, *, permissions: PermissionsType, role: str) -> None: ...
    def remove_permissions(self, *, permissions: PermissionsType, role: str) -> None: ...
